import 'dart:collection';

import 'package:objd/basic/condition.dart';
import 'package:objd/basic/entity.dart';
import 'package:objd/basic/score.dart';
import 'package:objd/basic/scoreboard.dart';
import 'package:objd/basic/widget.dart';

class Delay {
	static const String Name = "dabric_delay";

	static final HashMap<int, Score> _delays = HashMap();

	static List<Widget> init() {
		addDelay(2);
		addDelay(5);
		addDelay(10);
		addDelay(20);

		return [
			Scoreboard(Name, addIntoLoad: false),
			..._delays.values
		];
	}

	static void addDelay(int ticks) {
		_delays.addEntries([
			MapEntry(ticks, Score(Entity.PlayerName('#${ticks}'), Name, addNew: false).set(ticks))
		]);
	}

	static Condition ticks(int ticks, List<Widget> children) {
		return Condition.score(Score(Entity.Selected(), Name, addNew: false).modulo(_delays[ticks]));
	}
}
